blob: 4640ed90dd632b3c172b20bbde99bd7501b282b8 [file] [log] [blame]
Scott Anderson1a5fc952012-03-07 17:15:06 -08001function hmm() {
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07002cat <<EOF
Jeff Gastonc6dfc4e2017-05-30 17:12:37 -07003
4Run "m help" for help with the build system itself.
5
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08006Invoke ". build/envsetup.sh" from your shell to add the following functions to your environment:
Steven Moreland62054a42018-12-06 10:11:40 -08007- lunch: lunch <product_name>-<build_variant>
8 Selects <product_name> as the product to build, and <build_variant> as the variant to
9 build, and stores those selections in the environment to be read by subsequent
10 invocations of 'm' etc.
Elliott Hughesf71c05a2020-03-06 16:46:59 -080011- tapas: tapas [<App1> <App2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
Martin Stjernholmf692c752021-04-12 00:01:10 +010012 Sets up the build environment for building unbundled apps (APKs).
13- banchan: banchan <module1> [<module2> ...] [arm|x86|arm64|x86_64] [eng|userdebug|user]
14 Sets up the build environment for building unbundled modules (APEXes).
Anton Hanssonece9c482019-02-04 18:15:39 +000015- croot: Changes directory to the top of the tree, or a subdirectory thereof.
Steven Moreland62054a42018-12-06 10:11:40 -080016- m: Makes from the top of the tree.
Dan Willemsen67074fe2019-10-30 12:35:34 -070017- mm: Builds and installs all of the modules in the current directory, and their
18 dependencies.
19- mmm: Builds and installs all of the modules in the supplied directories, and their
20 dependencies.
Steven Moreland62054a42018-12-06 10:11:40 -080021 To limit the modules being built use the syntax: mmm dir/:target1,target2.
Dan Willemsen67074fe2019-10-30 12:35:34 -070022- mma: Same as 'mm'
23- mmma: Same as 'mmm'
Steven Moreland62054a42018-12-06 10:11:40 -080024- provision: Flash device with all required partitions. Options will be passed on to fastboot.
25- cgrep: Greps on all local C/C++ files.
26- ggrep: Greps on all local Gradle files.
Orion Hodson831472d2019-10-25 11:35:15 +010027- gogrep: Greps on all local Go files.
Steven Moreland62054a42018-12-06 10:11:40 -080028- jgrep: Greps on all local Java files.
Taesu Leeea0cecd2020-10-28 11:05:18 +090029- ktgrep: Greps on all local Kotlin files.
Steven Moreland62054a42018-12-06 10:11:40 -080030- resgrep: Greps on all local res/*.xml files.
31- mangrep: Greps on all local AndroidManifest.xml files.
Jaewoong Jung892d0fe2019-05-04 10:06:28 -070032- mgrep: Greps on all local Makefiles and *.bp files.
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -060033- owngrep: Greps on all local OWNERS files.
Alistair Delva176e5342021-02-22 13:31:26 -080034- rsgrep: Greps on all local Rust files.
Steven Moreland62054a42018-12-06 10:11:40 -080035- sepgrep: Greps on all local sepolicy files.
36- sgrep: Greps on all local source files.
37- godir: Go to the directory containing a file.
38- allmod: List all modules.
39- gomod: Go to the directory containing a module.
Rett Berg78d1c932019-01-24 14:34:23 -080040- pathmod: Get the directory containing a module.
Cole Faust24c36db2021-01-23 02:39:37 +000041- outmod: Gets the location of a module's installed outputs with a certain extension.
Joe Onorato2c1aa472021-02-25 16:42:39 -080042- dirmods: Gets the modules defined in a given directory.
Cole Faust24c36db2021-01-23 02:39:37 +000043- installmod: Adb installs a module's built APK.
44- refreshmod: Refresh list of modules for allmod/gomod/pathmod/outmod/installmod.
Steven Moreland74114f12020-09-10 01:23:32 +000045- syswrite: Remount partitions (e.g. system.img) as writable, rebooting if necessary.
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070046
Roland Levillain39341922015-10-20 12:48:19 +010047Environment options:
Steven Moreland115d1f52019-09-26 16:30:28 -070048- SANITIZE_HOST: Set to 'address' to use ASAN for all host modules.
Sasha Smundak9f27cc02019-01-31 13:25:31 -080049- ANDROID_QUIET_BUILD: set to 'true' to display only the essential messages.
Dan Albert4ae5d4b2014-10-31 16:23:08 -070050
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070051Look at the source to view more functions. The complete list is:
52EOF
Christopher Ferris55257d22017-03-23 11:08:58 -070053 local T=$(gettop)
54 local A=""
55 local i
Jacky Cao89483b82015-05-15 22:12:53 +080056 for i in `cat $T/build/envsetup.sh | sed -n "/^[[:blank:]]*function /s/function \([a-z_]*\).*/\1/p" | sort | uniq`; do
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -070057 A="$A $i"
58 done
59 echo $A
60}
61
Ying Wang08800fd2016-03-03 20:57:21 -080062# Get all the build variables needed by this script in a single call to the build system.
Matt Alexanderd9c56562020-05-21 10:49:17 +000063function build_build_var_cache()
64{
Christopher Ferris55257d22017-03-23 11:08:58 -070065 local T=$(gettop)
Ying Wang08800fd2016-03-03 20:57:21 -080066 # Grep out the variable names from the script.
Jim Tanga881a252018-06-19 16:34:41 +080067 cached_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
68 cached_abs_vars=(`cat $T/build/envsetup.sh | tr '()' ' ' | awk '{for(i=1;i<=NF;i++) if($i~/get_abs_build_var/) print $(i+1)}' | sort -u | tr '\n' ' '`)
Ying Wang08800fd2016-03-03 20:57:21 -080069 # Call the build system to dump the "<val>=<value>" pairs as a shell script.
Steven Moreland05402962018-01-05 12:13:11 -080070 build_dicts_script=`\builtin cd $T; build/soong/soong_ui.bash --dumpvars-mode \
Jim Tanga881a252018-06-19 16:34:41 +080071 --vars="${cached_vars[*]}" \
72 --abs-vars="${cached_abs_vars[*]}" \
Dan Willemsenaf88c412017-07-14 11:29:44 -070073 --var-prefix=var_cache_ \
74 --abs-var-prefix=abs_var_cache_`
Ying Wang08800fd2016-03-03 20:57:21 -080075 local ret=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +000076 if [ $ret -ne 0 ]
77 then
Ying Wang08800fd2016-03-03 20:57:21 -080078 unset build_dicts_script
79 return $ret
80 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -070081 # Execute the script to store the "<val>=<value>" pairs as shell variables.
Ying Wang08800fd2016-03-03 20:57:21 -080082 eval "$build_dicts_script"
Ying Wang08800fd2016-03-03 20:57:21 -080083 ret=$?
Ying Wangf0cb3972016-03-04 13:56:23 -080084 unset build_dicts_script
Matt Alexanderd9c56562020-05-21 10:49:17 +000085 if [ $ret -ne 0 ]
86 then
Ying Wang08800fd2016-03-03 20:57:21 -080087 return $ret
88 fi
89 BUILD_VAR_CACHE_READY="true"
90}
91
Ying Wangf0cb3972016-03-04 13:56:23 -080092# Delete the build var cache, so that we can still call into the build system
Ying Wang08800fd2016-03-03 20:57:21 -080093# to get build variables not listed in this script.
Matt Alexanderd9c56562020-05-21 10:49:17 +000094function destroy_build_var_cache()
95{
Ying Wang08800fd2016-03-03 20:57:21 -080096 unset BUILD_VAR_CACHE_READY
Christopher Ferris55257d22017-03-23 11:08:58 -070097 local v
Ying Wang08800fd2016-03-03 20:57:21 -080098 for v in $cached_vars; do
99 unset var_cache_$v
100 done
101 unset cached_vars
102 for v in $cached_abs_vars; do
103 unset abs_var_cache_$v
104 done
105 unset cached_abs_vars
106}
107
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700108# Get the value of a build variable as an absolute path.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000109function get_abs_build_var()
110{
111 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
112 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800113 eval "echo \"\${abs_var_cache_$1}\""
Timi0469c3f2021-04-15 16:41:18 +0200114 return
Ying Wang08800fd2016-03-03 20:57:21 -0800115 fi
116
Christopher Ferris55257d22017-03-23 11:08:58 -0700117 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700118 if [ ! "$T" ]; then
119 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
120 return
121 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700122 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode --abs $1)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700123}
124
125# Get the exact value of a build variable.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000126function get_build_var()
127{
128 if [ "$BUILD_VAR_CACHE_READY" = "true" ]
129 then
Vishwath Mohan7d35f002016-03-11 10:00:40 -0800130 eval "echo \"\${var_cache_$1}\""
Roland Levillain23c46cf2020-03-31 16:11:05 +0100131 return 0
Ying Wang08800fd2016-03-03 20:57:21 -0800132 fi
133
Christopher Ferris55257d22017-03-23 11:08:58 -0700134 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700135 if [ ! "$T" ]; then
136 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
Roland Levillain23c46cf2020-03-31 16:11:05 +0100137 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700138 fi
Dan Willemsenaf88c412017-07-14 11:29:44 -0700139 (\cd $T; build/soong/soong_ui.bash --dumpvar-mode $1)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800140}
141
142# check to see if the supplied product is one we can build
Matt Alexanderd9c56562020-05-21 10:49:17 +0000143function check_product()
144{
Christopher Ferris55257d22017-03-23 11:08:58 -0700145 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800146 if [ ! "$T" ]; then
147 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
148 return
149 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700150 TARGET_PRODUCT=$1 \
151 TARGET_BUILD_VARIANT= \
152 TARGET_BUILD_TYPE= \
Joe Onoratoda12daf2010-06-09 18:18:31 -0700153 TARGET_BUILD_APPS= \
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800154 get_build_var TARGET_DEVICE > /dev/null
155 # hide successful answers, but allow the errors to show
156}
157
158VARIANT_CHOICES=(user userdebug eng)
159
160# check to see if the supplied variant is valid
Matt Alexanderd9c56562020-05-21 10:49:17 +0000161function check_variant()
162{
Christopher Ferris55257d22017-03-23 11:08:58 -0700163 local v
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800164 for v in ${VARIANT_CHOICES[@]}
165 do
Matt Alexanderd9c56562020-05-21 10:49:17 +0000166 if [ "$v" = "$1" ]
167 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800168 return 0
169 fi
170 done
171 return 1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700172}
173
Matt Alexanderd9c56562020-05-21 10:49:17 +0000174function setpaths()
175{
Christopher Ferris55257d22017-03-23 11:08:58 -0700176 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700177 if [ ! "$T" ]; then
178 echo "Couldn't locate the top of the tree. Try setting TOP."
179 return
180 fi
181
182 ##################################################################
183 # #
184 # Read me before you modify this code #
185 # #
186 # This function sets ANDROID_BUILD_PATHS to what it is adding #
187 # to PATH, and the next time it is run, it removes that from #
188 # PATH. This is required so lunch can be run more than once #
189 # and still have working paths. #
190 # #
191 ##################################################################
192
Raphael Mollc639c782011-06-20 17:25:01 -0700193 # Note: on windows/cygwin, ANDROID_BUILD_PATHS will contain spaces
194 # due to "C:\Program Files" being in the path.
195
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700196 # out with the old
Matt Alexanderd9c56562020-05-21 10:49:17 +0000197 if [ -n "$ANDROID_BUILD_PATHS" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700198 export PATH=${PATH/$ANDROID_BUILD_PATHS/}
199 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000200 if [ -n "$ANDROID_PRE_BUILD_PATHS" ] ; then
Doug Zongker29034982011-04-22 08:16:56 -0700201 export PATH=${PATH/$ANDROID_PRE_BUILD_PATHS/}
Ying Wangaa1c9b52012-11-26 20:51:59 -0800202 # strip leading ':', if any
203 export PATH=${PATH/:%/}
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500204 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700205
206 # and in with the new
Christopher Ferris55257d22017-03-23 11:08:58 -0700207 local prebuiltdir=$(getprebuilt)
208 local gccprebuiltdir=$(get_abs_build_var ANDROID_GCC_PREBUILTS)
Raphael732936d2011-06-22 14:35:32 -0700209
Ben Cheng8bc4c432012-11-16 13:29:13 -0800210 # defined in core/config.mk
Christopher Ferris55257d22017-03-23 11:08:58 -0700211 local targetgccversion=$(get_build_var TARGET_GCC_VERSION)
212 local targetgccversion2=$(get_build_var 2ND_TARGET_GCC_VERSION)
Ben Cheng15266702012-12-10 16:04:39 -0800213 export TARGET_GCC_VERSION=$targetgccversion
Ben Cheng8bc4c432012-11-16 13:29:13 -0800214
Raphael Mollc639c782011-06-20 17:25:01 -0700215 # The gcc toolchain does not exists for windows/cygwin. In this case, do not reference it.
Ben Chengfba67bf2014-02-25 10:27:07 -0800216 export ANDROID_TOOLCHAIN=
217 export ANDROID_TOOLCHAIN_2ND_ARCH=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200218 local ARCH=$(get_build_var TARGET_ARCH)
Christopher Ferris55257d22017-03-23 11:08:58 -0700219 local toolchaindir toolchaindir2=
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200220 case $ARCH in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000221 x86) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Mark D Horn7d0ede72012-03-14 14:20:30 -0700222 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000223 x86_64) toolchaindir=x86/x86_64-linux-android-$targetgccversion/bin
Pavel Chupinfd82a492012-11-26 09:50:07 +0400224 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000225 arm) toolchaindir=arm/arm-linux-androideabi-$targetgccversion/bin
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200226 ;;
Matt Alexanderd9c56562020-05-21 10:49:17 +0000227 arm64) toolchaindir=aarch64/aarch64-linux-android-$targetgccversion/bin;
228 toolchaindir2=arm/arm-linux-androideabi-$targetgccversion2/bin
Ben Chengdb4fc202013-10-04 16:02:59 -0700229 ;;
David 'Digit' Turner2056c252012-04-17 14:50:47 +0200230 *)
231 echo "Can't find toolchain for unknown architecture: $ARCH"
232 toolchaindir=xxxxxxxxx
Mark D Horn7d0ede72012-03-14 14:20:30 -0700233 ;;
234 esac
Jing Yuf5172c72012-03-29 20:45:50 -0700235 if [ -d "$gccprebuiltdir/$toolchaindir" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800236 export ANDROID_TOOLCHAIN=$gccprebuiltdir/$toolchaindir
Raphael Mollc639c782011-06-20 17:25:01 -0700237 fi
Raphael732936d2011-06-22 14:35:32 -0700238
Christopher Ferris55257d22017-03-23 11:08:58 -0700239 if [ "$toolchaindir2" -a -d "$gccprebuiltdir/$toolchaindir2" ]; then
Ben Chengfba67bf2014-02-25 10:27:07 -0800240 export ANDROID_TOOLCHAIN_2ND_ARCH=$gccprebuiltdir/$toolchaindir2
241 fi
242
Dan Willemsen838dcec2021-09-30 22:40:34 +0000243 export ANDROID_DEV_SCRIPTS=$T/development/scripts:$T/prebuilts/devtools/tools
Yueyao Zhuefc786a2017-04-07 14:11:54 -0700244
245 # add kernel specific binaries
246 case $(uname -s) in
247 Linux)
248 export ANDROID_DEV_SCRIPTS=$ANDROID_DEV_SCRIPTS:$T/prebuilts/misc/linux-x86/dtc:$T/prebuilts/misc/linux-x86/libufdt
249 ;;
250 *)
251 ;;
252 esac
253
Torne (Richard Coles)0091bae2017-10-03 16:31:18 -0400254 ANDROID_BUILD_PATHS=$(get_build_var ANDROID_BUILD_PATHS):$ANDROID_TOOLCHAIN
Martin Stjernholm6a012262021-11-24 14:56:15 +0000255 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_TOOLCHAIN_2ND_ARCH
Yi Kongdfd00b12019-05-21 16:00:04 -0700256 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_DEV_SCRIPTS
257
258 # Append llvm binutils prebuilts path to ANDROID_BUILD_PATHS.
259 local ANDROID_LLVM_BINUTILS=$(get_abs_build_var ANDROID_CLANG_PREBUILTS)/llvm-binutils-stable
260 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_LLVM_BINUTILS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200261
Stephen Hinesaa8d72c2020-02-04 09:15:18 -0800262 # Set up ASAN_SYMBOLIZER_PATH for SANITIZE_HOST=address builds.
263 export ASAN_SYMBOLIZER_PATH=$ANDROID_LLVM_BINUTILS/llvm-symbolizer
264
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200265 # If prebuilts/android-emulator/<system>/ exists, prepend it to our PATH
266 # to ensure that the corresponding 'emulator' binaries are used.
267 case $(uname -s) in
268 Darwin)
269 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/darwin-x86_64
270 ;;
271 Linux)
272 ANDROID_EMULATOR_PREBUILTS=$T/prebuilts/android-emulator/linux-x86_64
273 ;;
274 *)
275 ANDROID_EMULATOR_PREBUILTS=
276 ;;
277 esac
278 if [ -n "$ANDROID_EMULATOR_PREBUILTS" -a -d "$ANDROID_EMULATOR_PREBUILTS" ]; then
Yi Kongdfd00b12019-05-21 16:00:04 -0700279 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ANDROID_EMULATOR_PREBUILTS
David 'Digit' Turner94d16e52014-05-05 16:13:50 +0200280 export ANDROID_EMULATOR_PREBUILTS
281 fi
282
Jim Tangb3fda302018-12-22 10:24:55 +0800283 # Append asuite prebuilts path to ANDROID_BUILD_PATHS.
284 local os_arch=$(get_build_var HOST_PREBUILT_TAG)
Ryan Prichard8426a192019-07-15 18:05:29 -0700285 local ACLOUD_PATH="$T/prebuilts/asuite/acloud/$os_arch"
286 local AIDEGEN_PATH="$T/prebuilts/asuite/aidegen/$os_arch"
287 local ATEST_PATH="$T/prebuilts/asuite/atest/$os_arch"
Martin Stjernholm6a012262021-11-24 14:56:15 +0000288 ANDROID_BUILD_PATHS=$ANDROID_BUILD_PATHS:$ACLOUD_PATH:$AIDEGEN_PATH:$ATEST_PATH
Jim Tangb3fda302018-12-22 10:24:55 +0800289
Martin Stjernholm6a012262021-11-24 14:56:15 +0000290 export ANDROID_BUILD_PATHS=$(tr -s : <<<"${ANDROID_BUILD_PATHS}:")
Ryan Prichard8426a192019-07-15 18:05:29 -0700291 export PATH=$ANDROID_BUILD_PATHS$PATH
Jim Tang22f4c322018-12-17 15:21:53 +0800292
293 # out with the duplicate old
294 if [ -n $ANDROID_PYTHONPATH ]; then
295 export PYTHONPATH=${PYTHONPATH//$ANDROID_PYTHONPATH/}
296 fi
297 # and in with the new
298 export ANDROID_PYTHONPATH=$T/development/python-packages:
Jim Tangc4dba1d2019-07-25 16:54:27 +0800299 if [ -n $VENDOR_PYTHONPATH ]; then
300 ANDROID_PYTHONPATH=$ANDROID_PYTHONPATH$VENDOR_PYTHONPATH
301 fi
Jim Tang22f4c322018-12-17 15:21:53 +0800302 export PYTHONPATH=$ANDROID_PYTHONPATH$PYTHONPATH
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800303
Colin Crosse97e6932017-06-30 16:01:45 -0700304 export ANDROID_JAVA_HOME=$(get_abs_build_var ANDROID_JAVA_HOME)
305 export JAVA_HOME=$ANDROID_JAVA_HOME
306 export ANDROID_JAVA_TOOLCHAIN=$(get_abs_build_var ANDROID_JAVA_TOOLCHAIN)
307 export ANDROID_PRE_BUILD_PATHS=$ANDROID_JAVA_TOOLCHAIN:
308 export PATH=$ANDROID_PRE_BUILD_PATHS$PATH
Jeff Hamilton4a1c70e2010-06-21 18:26:38 -0500309
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800310 unset ANDROID_PRODUCT_OUT
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700311 export ANDROID_PRODUCT_OUT=$(get_abs_build_var PRODUCT_OUT)
312 export OUT=$ANDROID_PRODUCT_OUT
313
Jeff Brown8fd5cce2011-03-24 17:03:06 -0700314 unset ANDROID_HOST_OUT
315 export ANDROID_HOST_OUT=$(get_abs_build_var HOST_OUT)
316
Jiyong Parkc02b1c42020-11-03 11:06:39 +0900317 unset ANDROID_SOONG_HOST_OUT
318 export ANDROID_SOONG_HOST_OUT=$(get_abs_build_var SOONG_HOST_OUT)
319
Simran Basidd050ed2017-02-13 13:46:48 -0800320 unset ANDROID_HOST_OUT_TESTCASES
321 export ANDROID_HOST_OUT_TESTCASES=$(get_abs_build_var HOST_OUT_TESTCASES)
322
323 unset ANDROID_TARGET_OUT_TESTCASES
324 export ANDROID_TARGET_OUT_TESTCASES=$(get_abs_build_var TARGET_OUT_TESTCASES)
325
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800326 # needed for building linux on MacOS
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700327 # TODO: fix the path
328 #export HOST_EXTRACFLAGS="-I "$T/system/kernel_headers/host_include
329}
330
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000331function bazel()
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000332{
Jingwen Chen17d56992021-06-10 08:17:54 +0000333 if which bazel &>/dev/null; then
334 >&2 echo "NOTE: bazel() function sourced from Android's envsetup.sh is being used instead of $(which bazel)"
335 >&2 echo
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000336 fi
337
Jingwen Chen17d56992021-06-10 08:17:54 +0000338 local T="$(gettop)"
339 if [ ! "$T" ]; then
340 >&2 echo "Couldn't locate the top of the Android tree. Try setting TOP. This bazel() function cannot be used outside of the AOSP directory."
341 return
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000342 fi
343
Rupert Shuttleworth5d60d022020-10-25 05:20:03 +0000344 "$T/tools/bazel" "$@"
Rupert Shuttleworth131fa7d2020-10-12 13:41:12 +0000345}
346
Matt Alexanderd9c56562020-05-21 10:49:17 +0000347function printconfig()
348{
Christopher Ferris55257d22017-03-23 11:08:58 -0700349 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800350 if [ ! "$T" ]; then
351 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
352 return
353 fi
354 get_build_var report_config
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700355}
356
Matt Alexanderd9c56562020-05-21 10:49:17 +0000357function set_stuff_for_environment()
358{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800359 setpaths
360 set_sequence_number
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700361
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800362 export ANDROID_BUILD_TOP=$(gettop)
Ben Chengaac3f812013-08-13 14:38:15 -0700363 # With this environment variable new GCC can apply colors to warnings/errors
364 export GCC_COLORS='error=01;31:warning=01;35:note=01;36:caret=01;32:locus=01:quote=01'
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700365}
366
Matt Alexanderd9c56562020-05-21 10:49:17 +0000367function set_sequence_number()
368{
Colin Cross88737132017-03-21 17:41:03 -0700369 export BUILD_ENV_SEQUENCE_NUMBER=13
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700370}
371
Makoto Onukida971062018-06-18 10:15:19 -0700372# Takes a command name, and check if it's in ENVSETUP_NO_COMPLETION or not.
373function should_add_completion() {
Jim Tanga881a252018-06-19 16:34:41 +0800374 local cmd="$(basename $1| sed 's/_completion//' |sed 's/\.\(.*\)*sh$//')"
Makoto Onukida971062018-06-18 10:15:19 -0700375 case :"$ENVSETUP_NO_COMPLETION": in
Jim Tanga881a252018-06-19 16:34:41 +0800376 *:"$cmd":*)
377 return 1
378 ;;
Makoto Onukida971062018-06-18 10:15:19 -0700379 esac
380 return 0
381}
382
Matt Alexanderd9c56562020-05-21 10:49:17 +0000383function addcompletions()
384{
Ben Taitelbaum8c2c9cf2020-09-22 16:45:05 -0700385 local f=
Kenny Root52aa81c2011-07-15 11:07:06 -0700386
Jim Tanga881a252018-06-19 16:34:41 +0800387 # Keep us from trying to run in something that's neither bash nor zsh.
388 if [ -z "$BASH_VERSION" -a -z "$ZSH_VERSION" ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700389 return
390 fi
391
392 # Keep us from trying to run in bash that's too old.
Jim Tanga881a252018-06-19 16:34:41 +0800393 if [ -n "$BASH_VERSION" -a ${BASH_VERSINFO[0]} -lt 3 ]; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700394 return
395 fi
396
Jim Tanga881a252018-06-19 16:34:41 +0800397 local completion_files=(
398 system/core/adb/adb.bash
399 system/core/fastboot/fastboot.bash
Jim Tangb3fda302018-12-22 10:24:55 +0800400 tools/asuite/asuite.sh
Jim Tanga881a252018-06-19 16:34:41 +0800401 )
Makoto Onukida971062018-06-18 10:15:19 -0700402 # Completion can be disabled selectively to allow users to use non-standard completion.
403 # e.g.
404 # ENVSETUP_NO_COMPLETION=adb # -> disable adb completion
405 # ENVSETUP_NO_COMPLETION=adb:bit # -> disable adb and bit completion
Jim Tanga881a252018-06-19 16:34:41 +0800406 for f in ${completion_files[*]}; do
407 if [ -f "$f" ] && should_add_completion "$f"; then
Kenny Root52aa81c2011-07-15 11:07:06 -0700408 . $f
Elliott Hughesce18dd42018-04-03 13:49:48 -0700409 fi
410 done
Joe Onorato002a6c72016-10-20 16:39:49 -0700411
Matt Alexanderd9c56562020-05-21 10:49:17 +0000412 if should_add_completion bit ; then
Makoto Onukida971062018-06-18 10:15:19 -0700413 complete -C "bit --tab" bit
414 fi
Anton Hanssonece9c482019-02-04 18:15:39 +0000415 if [ -z "$ZSH_VERSION" ]; then
416 # Doesn't work in zsh.
417 complete -o nospace -F _croot croot
418 fi
Jim Tanga881a252018-06-19 16:34:41 +0800419 complete -F _lunch lunch
Steven Moreland62054a42018-12-06 10:11:40 -0800420
Cole Faust24c36db2021-01-23 02:39:37 +0000421 complete -F _complete_android_module_names pathmod
dimitry73b84812018-12-11 18:06:00 +0100422 complete -F _complete_android_module_names gomod
Cole Faust24c36db2021-01-23 02:39:37 +0000423 complete -F _complete_android_module_names outmod
424 complete -F _complete_android_module_names installmod
dimitry73b84812018-12-11 18:06:00 +0100425 complete -F _complete_android_module_names m
Kenny Root52aa81c2011-07-15 11:07:06 -0700426}
427
Matt Alexanderd9c56562020-05-21 10:49:17 +0000428function choosetype()
429{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700430 echo "Build type choices are:"
431 echo " 1. release"
432 echo " 2. debug"
433 echo
434
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800435 local DEFAULT_NUM DEFAULT_VALUE
Jeff Browne33ba4c2011-07-11 22:11:46 -0700436 DEFAULT_NUM=1
437 DEFAULT_VALUE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700438
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800439 export TARGET_BUILD_TYPE=
440 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700441 while [ -z $TARGET_BUILD_TYPE ]
442 do
443 echo -n "Which would you like? ["$DEFAULT_NUM"] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000444 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800445 read ANSWER
446 else
447 echo $1
448 ANSWER=$1
449 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700450 case $ANSWER in
451 "")
452 export TARGET_BUILD_TYPE=$DEFAULT_VALUE
453 ;;
454 1)
455 export TARGET_BUILD_TYPE=release
456 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800457 release)
458 export TARGET_BUILD_TYPE=release
459 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700460 2)
461 export TARGET_BUILD_TYPE=debug
462 ;;
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800463 debug)
464 export TARGET_BUILD_TYPE=debug
465 ;;
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700466 *)
467 echo
468 echo "I didn't understand your response. Please try again."
469 echo
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700470 ;;
471 esac
Matt Alexanderd9c56562020-05-21 10:49:17 +0000472 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800473 break
474 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700475 done
476
Ying Wang08800fd2016-03-03 20:57:21 -0800477 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700478 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800479 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700480}
481
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800482#
483# This function isn't really right: It chooses a TARGET_PRODUCT
484# based on the list of boards. Usually, that gets you something
485# that kinda works with a generic product, but really, you should
486# pick a product by name.
487#
Matt Alexanderd9c56562020-05-21 10:49:17 +0000488function chooseproduct()
489{
Christopher Ferris55257d22017-03-23 11:08:58 -0700490 local default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000491 if [ "x$TARGET_PRODUCT" != x ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700492 default_value=$TARGET_PRODUCT
493 else
Ying Wang0a76df52015-06-08 11:57:26 -0700494 default_value=aosp_arm
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700495 fi
496
Ying Wang08800fd2016-03-03 20:57:21 -0800497 export TARGET_BUILD_APPS=
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800498 export TARGET_PRODUCT=
499 local ANSWER
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700500 while [ -z "$TARGET_PRODUCT" ]
501 do
Joe Onorato8849aed2009-04-29 15:56:47 -0700502 echo -n "Which product would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000503 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800504 read ANSWER
505 else
506 echo $1
507 ANSWER=$1
508 fi
509
Matt Alexanderd9c56562020-05-21 10:49:17 +0000510 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700511 export TARGET_PRODUCT=$default_value
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800512 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000513 if check_product $ANSWER
514 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800515 export TARGET_PRODUCT=$ANSWER
516 else
517 echo "** Not a valid product: $ANSWER"
518 fi
519 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000520 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800521 break
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700522 fi
523 done
524
Ying Wang08800fd2016-03-03 20:57:21 -0800525 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700526 set_stuff_for_environment
Ying Wang08800fd2016-03-03 20:57:21 -0800527 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700528}
529
Matt Alexanderd9c56562020-05-21 10:49:17 +0000530function choosevariant()
531{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800532 echo "Variant choices are:"
533 local index=1
534 local v
535 for v in ${VARIANT_CHOICES[@]}
536 do
537 # The product name is the name of the directory containing
538 # the makefile we found, above.
539 echo " $index. $v"
540 index=$(($index+1))
541 done
542
543 local default_value=eng
544 local ANSWER
545
546 export TARGET_BUILD_VARIANT=
547 while [ -z "$TARGET_BUILD_VARIANT" ]
548 do
549 echo -n "Which would you like? [$default_value] "
Matt Alexanderd9c56562020-05-21 10:49:17 +0000550 if [ -z "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800551 read ANSWER
552 else
553 echo $1
554 ANSWER=$1
555 fi
556
Matt Alexanderd9c56562020-05-21 10:49:17 +0000557 if [ -z "$ANSWER" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800558 export TARGET_BUILD_VARIANT=$default_value
Matt Alexanderd9c56562020-05-21 10:49:17 +0000559 elif (echo -n $ANSWER | grep -q -e "^[0-9][0-9]*$") ; then
560 if [ "$ANSWER" -le "${#VARIANT_CHOICES[@]}" ] ; then
Guillaume Chelfice000fd2019-10-03 12:02:46 +0200561 export TARGET_BUILD_VARIANT=${VARIANT_CHOICES[@]:$(($ANSWER-1)):1}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800562 fi
563 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000564 if check_variant $ANSWER
565 then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800566 export TARGET_BUILD_VARIANT=$ANSWER
567 else
568 echo "** Not a valid variant: $ANSWER"
569 fi
570 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +0000571 if [ -n "$1" ] ; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800572 break
573 fi
574 done
575}
576
Matt Alexanderd9c56562020-05-21 10:49:17 +0000577function choosecombo()
578{
Jeff Browne33ba4c2011-07-11 22:11:46 -0700579 choosetype $1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700580
581 echo
582 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700583 chooseproduct $2
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700584
585 echo
586 echo
Jeff Browne33ba4c2011-07-11 22:11:46 -0700587 choosevariant $3
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800588
589 echo
Ying Wang08800fd2016-03-03 20:57:21 -0800590 build_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700591 set_stuff_for_environment
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800592 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800593 destroy_build_var_cache
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700594}
595
Matt Alexanderd9c56562020-05-21 10:49:17 +0000596function add_lunch_combo()
597{
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800598 if [ -n "$ZSH_VERSION" ]; then
599 echo -n "${funcfiletrace[1]}: "
600 else
601 echo -n "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: "
602 fi
603 echo "add_lunch_combo is obsolete. Use COMMON_LUNCH_CHOICES in your AndroidProducts.mk instead."
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800604}
605
Matt Alexanderd9c56562020-05-21 10:49:17 +0000606function print_lunch_menu()
607{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700608 local uname=$(uname)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100609 local choices
Colin Crossfa50d402021-04-22 13:05:41 -0700610 choices=$(TARGET_BUILD_APPS= TARGET_PRODUCT= TARGET_BUILD_VARIANT= get_build_var COMMON_LUNCH_CHOICES 2>/dev/null)
Roland Levillain23c46cf2020-03-31 16:11:05 +0100611 local ret=$?
612
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700613 echo
614 echo "You're building on" $uname
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700615 echo
Roland Levillain23c46cf2020-03-31 16:11:05 +0100616
Matt Alexanderd9c56562020-05-21 10:49:17 +0000617 if [ $ret -ne 0 ]
618 then
Roland Levillain23c46cf2020-03-31 16:11:05 +0100619 echo "Warning: Cannot display lunch menu."
620 echo
621 echo "Note: You can invoke lunch with an explicit target:"
622 echo
623 echo " usage: lunch [target]" >&2
624 echo
625 return
626 fi
627
Will Burr40401202022-02-07 12:12:01 +0000628 echo "Lunch menu .. Here are the common combinations:"
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800629
630 local i=1
631 local choice
Dan Willemsen91763e92019-10-03 15:13:12 -0700632 for choice in $(echo $choices)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800633 do
634 echo " $i. $choice"
635 i=$(($i+1))
636 done
637
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700638 echo
639}
640
Matt Alexanderd9c56562020-05-21 10:49:17 +0000641function lunch()
642{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800643 local answer
644
Steven Moreland92793dc2020-02-25 18:30:18 -0800645 if [[ $# -gt 1 ]]; then
646 echo "usage: lunch [target]" >&2
647 return 1
648 fi
649
Will Burr40401202022-02-07 12:12:01 +0000650 local used_lunch_menu=0
651
Steven Moreland92793dc2020-02-25 18:30:18 -0800652 if [ "$1" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800653 answer=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700654 else
655 print_lunch_menu
Will Burr40401202022-02-07 12:12:01 +0000656 echo "Which would you like? [aosp_arm-eng]"
657 echo -n "Pick from common choices above (e.g. 13) or specify your own (e.g. aosp_barbet-eng): "
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800658 read answer
Will Burr40401202022-02-07 12:12:01 +0000659 used_lunch_menu=1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700660 fi
661
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800662 local selection=
663
Matt Alexanderd9c56562020-05-21 10:49:17 +0000664 if [ -z "$answer" ]
665 then
Jean-Baptiste Queru324c1232013-03-22 15:53:54 -0700666 selection=aosp_arm-eng
Matt Alexanderd9c56562020-05-21 10:49:17 +0000667 elif (echo -n $answer | grep -q -e "^[0-9][0-9]*$")
668 then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800669 local choices=($(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES))
Matt Alexanderd9c56562020-05-21 10:49:17 +0000670 if [ $answer -le ${#choices[@]} ]
671 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800672 # array in zsh starts from 1 instead of 0.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000673 if [ -n "$ZSH_VERSION" ]
674 then
Jim Tang0e3397b2018-10-03 18:25:50 +0800675 selection=${choices[$(($answer))]}
676 else
677 selection=${choices[$(($answer-1))]}
678 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800679 fi
Colin Cross88737132017-03-21 17:41:03 -0700680 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800681 selection=$answer
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700682 fi
683
Joe Onoratoda12daf2010-06-09 18:18:31 -0700684 export TARGET_BUILD_APPS=
685
Colin Cross88737132017-03-21 17:41:03 -0700686 local product variant_and_version variant version
Colin Cross88737132017-03-21 17:41:03 -0700687 product=${selection%%-*} # Trim everything after first dash
688 variant_and_version=${selection#*-} # Trim everything up to first dash
689 if [ "$variant_and_version" != "$selection" ]; then
690 variant=${variant_and_version%%-*}
691 if [ "$variant" != "$variant_and_version" ]; then
692 version=${variant_and_version#*-}
693 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700694 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800695
Matt Alexanderd9c56562020-05-21 10:49:17 +0000696 if [ -z "$product" ]
697 then
Ying Wang08800fd2016-03-03 20:57:21 -0800698 echo
Colin Cross88737132017-03-21 17:41:03 -0700699 echo "Invalid lunch combo: $selection"
Jeff Browne33ba4c2011-07-11 22:11:46 -0700700 return 1
701 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800702
Colin Cross88737132017-03-21 17:41:03 -0700703 TARGET_PRODUCT=$product \
704 TARGET_BUILD_VARIANT=$variant \
705 TARGET_PLATFORM_VERSION=$version \
706 build_build_var_cache
Matt Alexanderd9c56562020-05-21 10:49:17 +0000707 if [ $? -ne 0 ]
708 then
Anton Hansson32fa7ee2021-06-14 17:09:58 +0100709 if [[ "$product" =~ .*_(eng|user|userdebug) ]]
710 then
711 echo "Did you mean -${product/*_/}? (dash instead of underscore)"
712 fi
Colin Cross88737132017-03-21 17:41:03 -0700713 return 1
714 fi
Colin Cross88737132017-03-21 17:41:03 -0700715 export TARGET_PRODUCT=$(get_build_var TARGET_PRODUCT)
716 export TARGET_BUILD_VARIANT=$(get_build_var TARGET_BUILD_VARIANT)
Colin Crossb105e362017-05-01 14:21:28 -0700717 if [ -n "$version" ]; then
718 export TARGET_PLATFORM_VERSION=$(get_build_var TARGET_PLATFORM_VERSION)
719 else
720 unset TARGET_PLATFORM_VERSION
721 fi
Jeff Browne33ba4c2011-07-11 22:11:46 -0700722 export TARGET_BUILD_TYPE=release
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700723
Will Burr40401202022-02-07 12:12:01 +0000724 if [ $used_lunch_menu -eq 1 ]; then
725 echo
726 echo "Hint: next time you can simply run 'lunch $selection'"
727 fi
728
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700729 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || echo
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800730
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700731 set_stuff_for_environment
Sasha Smundak90d07bc2020-06-04 10:48:15 -0700732 [[ -n "${ANDROID_QUIET_BUILD:-}" ]] || printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800733 destroy_build_var_cache
Kousik Kumar41dacd12021-05-11 18:38:38 -0400734
735 if [[ -n "${CHECK_MU_CONFIG:-}" ]]; then
736 check_mu_config
737 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700738}
739
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700740unset COMMON_LUNCH_CHOICES_CACHE
Jeff Davidson513d7a42010-08-02 10:00:44 -0700741# Tab completion for lunch.
Matt Alexanderd9c56562020-05-21 10:49:17 +0000742function _lunch()
743{
Jeff Davidson513d7a42010-08-02 10:00:44 -0700744 local cur prev opts
745 COMPREPLY=()
746 cur="${COMP_WORDS[COMP_CWORD]}"
747 prev="${COMP_WORDS[COMP_CWORD-1]}"
748
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700749 if [ -z "$COMMON_LUNCH_CHOICES_CACHE" ]; then
Dan Willemsen5436c7e2019-02-11 21:31:47 -0800750 COMMON_LUNCH_CHOICES_CACHE=$(TARGET_BUILD_APPS= get_build_var COMMON_LUNCH_CHOICES)
Dan Willemsenaf2e1f82018-04-04 15:41:41 -0700751 fi
752
753 COMPREPLY=( $(compgen -W "${COMMON_LUNCH_CHOICES_CACHE}" -- ${cur}) )
Jeff Davidson513d7a42010-08-02 10:00:44 -0700754 return 0
755}
Jeff Davidson513d7a42010-08-02 10:00:44 -0700756
Joe Onoratoda12daf2010-06-09 18:18:31 -0700757# Configures the build to build unbundled apps.
Doug Zongker0d8179e2014-04-16 11:34:34 -0700758# Run tapas with one or more app names (from LOCAL_PACKAGE_NAME)
Matt Alexanderd9c56562020-05-21 10:49:17 +0000759function tapas()
760{
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700761 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Elliott Hughesf71c05a2020-03-06 16:46:59 -0800762 local arch="$(echo $* | xargs -n 1 echo | \grep -E '^(arm|x86|arm64|x86_64)$' | xargs)"
Doug Zongker0d8179e2014-04-16 11:34:34 -0700763 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700764 local density="$(echo $* | xargs -n 1 echo | \grep -E '^(ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi)$' | xargs)"
Colin Cross7f49a672022-01-27 18:15:53 -0800765 local keys="$(echo $* | xargs -n 1 echo | \grep -E '^(devkeys)$' | xargs)"
766 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|arm|x86|arm64|x86_64|ldpi|mdpi|tvdpi|hdpi|xhdpi|xxhdpi|xxxhdpi|alldpi|devkeys)$' | xargs)"
767
Joe Onoratoda12daf2010-06-09 18:18:31 -0700768
Jeff Gaston9fb05d82017-08-21 18:27:00 -0700769 if [ "$showHelp" != "" ]; then
770 $(gettop)/build/make/tapasHelp.sh
771 return
772 fi
773
Ying Wang67f02922012-08-22 10:25:20 -0700774 if [ $(echo $arch | wc -w) -gt 1 ]; then
775 echo "tapas: Error: Multiple build archs supplied: $arch"
776 return
777 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700778 if [ $(echo $variant | wc -w) -gt 1 ]; then
779 echo "tapas: Error: Multiple build variants supplied: $variant"
780 return
781 fi
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700782 if [ $(echo $density | wc -w) -gt 1 ]; then
783 echo "tapas: Error: Multiple densities supplied: $density"
784 return
785 fi
Colin Cross7f49a672022-01-27 18:15:53 -0800786 if [ $(echo $keys | wc -w) -gt 1 ]; then
787 echo "tapas: Error: Multiple keys supplied: $keys"
788 return
789 fi
Ying Wang67f02922012-08-22 10:25:20 -0700790
Ying Wang0a76df52015-06-08 11:57:26 -0700791 local product=aosp_arm
Ying Wang67f02922012-08-22 10:25:20 -0700792 case $arch in
Matt Alexanderd9c56562020-05-21 10:49:17 +0000793 x86) product=aosp_x86;;
794 arm64) product=aosp_arm64;;
795 x86_64) product=aosp_x86_64;;
Ying Wang67f02922012-08-22 10:25:20 -0700796 esac
Colin Cross7f49a672022-01-27 18:15:53 -0800797 if [ -n "$keys" ]; then
798 product=${product/aosp_/aosp_${keys}_}
799 fi;
800
Joe Onoratoda12daf2010-06-09 18:18:31 -0700801 if [ -z "$variant" ]; then
802 variant=eng
803 fi
Ying Wangc048c9b2010-06-24 15:08:33 -0700804 if [ -z "$apps" ]; then
805 apps=all
806 fi
Justin Morey29d225c2014-11-04 13:35:51 -0600807 if [ -z "$density" ]; then
808 density=alldpi
809 fi
Joe Onoratoda12daf2010-06-09 18:18:31 -0700810
Ying Wang67f02922012-08-22 10:25:20 -0700811 export TARGET_PRODUCT=$product
Joe Onoratoda12daf2010-06-09 18:18:31 -0700812 export TARGET_BUILD_VARIANT=$variant
Jeff Hamilton5069bd62014-09-04 21:28:00 -0700813 export TARGET_BUILD_DENSITY=$density
Joe Onoratoda12daf2010-06-09 18:18:31 -0700814 export TARGET_BUILD_TYPE=release
815 export TARGET_BUILD_APPS=$apps
816
Ying Wang08800fd2016-03-03 20:57:21 -0800817 build_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700818 set_stuff_for_environment
819 printconfig
Ying Wang08800fd2016-03-03 20:57:21 -0800820 destroy_build_var_cache
Joe Onoratoda12daf2010-06-09 18:18:31 -0700821}
822
Martin Stjernholmf692c752021-04-12 00:01:10 +0100823# Configures the build to build unbundled Android modules (APEXes).
824# Run banchan with one or more module names (from apex{} modules).
825function banchan()
826{
827 local showHelp="$(echo $* | xargs -n 1 echo | \grep -E '^(help)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100828 local product="$(echo $* | xargs -n 1 echo | \grep -E '^(.*_)?(arm|x86|arm64|x86_64)$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100829 local variant="$(echo $* | xargs -n 1 echo | \grep -E '^(user|userdebug|eng)$' | xargs)"
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100830 local apps="$(echo $* | xargs -n 1 echo | \grep -E -v '^(user|userdebug|eng|(.*_)?(arm|x86|arm64|x86_64))$' | xargs)"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100831
832 if [ "$showHelp" != "" ]; then
833 $(gettop)/build/make/banchanHelp.sh
834 return
835 fi
836
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100837 if [ -z "$product" ]; then
838 product=arm
839 elif [ $(echo $product | wc -w) -gt 1 ]; then
840 echo "banchan: Error: Multiple build archs or products supplied: $products"
Martin Stjernholmf692c752021-04-12 00:01:10 +0100841 return
842 fi
843 if [ $(echo $variant | wc -w) -gt 1 ]; then
844 echo "banchan: Error: Multiple build variants supplied: $variant"
845 return
846 fi
847 if [ -z "$apps" ]; then
848 echo "banchan: Error: No modules supplied"
849 return
850 fi
851
Martin Stjernholm2b8d9232021-04-16 20:45:03 +0100852 case $product in
853 arm) product=module_arm;;
Martin Stjernholmf692c752021-04-12 00:01:10 +0100854 x86) product=module_x86;;
855 arm64) product=module_arm64;;
856 x86_64) product=module_x86_64;;
857 esac
858 if [ -z "$variant" ]; then
859 variant=eng
860 fi
861
862 export TARGET_PRODUCT=$product
863 export TARGET_BUILD_VARIANT=$variant
864 export TARGET_BUILD_DENSITY=alldpi
865 export TARGET_BUILD_TYPE=release
866
867 # This setup currently uses TARGET_BUILD_APPS just like tapas, but the use
868 # case is different and it may diverge in the future.
869 export TARGET_BUILD_APPS=$apps
870
871 build_build_var_cache
872 set_stuff_for_environment
873 printconfig
874 destroy_build_var_cache
875}
876
Matt Alexanderd9c56562020-05-21 10:49:17 +0000877function gettop
878{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700879 local TOPFILE=build/make/core/envsetup.mk
Matt Alexanderd9c56562020-05-21 10:49:17 +0000880 if [ -n "$TOP" -a -f "$TOP/$TOPFILE" ] ; then
Brian Carlstroma5c4f172014-09-12 00:33:25 -0700881 # The following circumlocution ensures we remove symlinks from TOP.
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000882 (cd "$TOP"; PWD= /bin/pwd)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700883 else
Matt Alexanderd9c56562020-05-21 10:49:17 +0000884 if [ -f $TOPFILE ] ; then
Dan Bornsteind0b274d2009-11-24 15:48:50 -0800885 # The following circumlocution (repeated below as well) ensures
886 # that we record the true directory name and not one that is
887 # faked up with symlink names.
888 PWD= /bin/pwd
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700889 else
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -0800890 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700891 local T=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000892 while [ \( ! \( -f $TOPFILE \) \) -a \( "$PWD" != "/" \) ]; do
Ying Wang9cd17642012-12-13 10:52:07 -0800893 \cd ..
synergyb112a402013-07-05 19:47:47 -0700894 T=`PWD= /bin/pwd -P`
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700895 done
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000896 \cd "$HERE"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700897 if [ -f "$T/$TOPFILE" ]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +0000898 echo "$T"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700899 fi
900 fi
901 fi
902}
903
Matt Alexanderd9c56562020-05-21 10:49:17 +0000904function croot()
905{
Christopher Ferris55257d22017-03-23 11:08:58 -0700906 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700907 if [ "$T" ]; then
Marie Janssen32ec50a2016-04-21 16:53:39 -0700908 if [ "$1" ]; then
909 \cd $(gettop)/$1
910 else
911 \cd $(gettop)
912 fi
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -0700913 else
914 echo "Couldn't locate the top of the tree. Try setting TOP."
915 fi
916}
917
Matt Alexanderd9c56562020-05-21 10:49:17 +0000918function _croot()
919{
Anton Hanssonece9c482019-02-04 18:15:39 +0000920 local T=$(gettop)
921 if [ "$T" ]; then
922 local cur="${COMP_WORDS[COMP_CWORD]}"
923 k=0
924 for c in $(compgen -d ${T}/${cur}); do
925 COMPREPLY[k++]=${c#${T}/}/
926 done
927 fi
928}
929
Matt Alexanderd9c56562020-05-21 10:49:17 +0000930function cproj()
931{
Colin Cross6cdc5d22017-10-20 11:37:33 -0700932 local TOPFILE=build/make/core/envsetup.mk
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700933 local HERE=$PWD
Christopher Ferris55257d22017-03-23 11:08:58 -0700934 local T=
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700935 while [ \( ! \( -f $TOPFILE \) \) -a \( $PWD != "/" \) ]; do
936 T=$PWD
937 if [ -f "$T/Android.mk" ]; then
Ying Wang9cd17642012-12-13 10:52:07 -0800938 \cd $T
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700939 return
940 fi
Ying Wang9cd17642012-12-13 10:52:07 -0800941 \cd ..
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700942 done
Ying Wang9cd17642012-12-13 10:52:07 -0800943 \cd $HERE
Joe Onorato2a5d4d82009-07-30 10:23:21 -0700944 echo "can't find Android.mk"
945}
946
Daniel Sandler47e0a882013-07-30 13:23:52 -0400947# simplified version of ps; output in the form
948# <pid> <procname>
949function qpid() {
950 local prepend=''
951 local append=''
Matt Alexanderd9c56562020-05-21 10:49:17 +0000952 if [ "$1" = "--exact" ]; then
Daniel Sandler47e0a882013-07-30 13:23:52 -0400953 prepend=' '
954 append='$'
955 shift
Matt Alexanderd9c56562020-05-21 10:49:17 +0000956 elif [ "$1" = "--help" -o "$1" = "-h" ]; then
Ying Wang08800fd2016-03-03 20:57:21 -0800957 echo "usage: qpid [[--exact] <process name|pid>"
958 return 255
959 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400960
961 local EXE="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +0000962 if [ "$EXE" ] ; then
Ying Wang08800fd2016-03-03 20:57:21 -0800963 qpid | \grep "$prepend$EXE$append"
964 else
965 adb shell ps \
966 | tr -d '\r' \
967 | sed -e 1d -e 's/^[^ ]* *\([0-9]*\).* \([^ ]*\)$/\1 \2/'
968 fi
Daniel Sandler47e0a882013-07-30 13:23:52 -0400969}
970
Steven Moreland74114f12020-09-10 01:23:32 +0000971# syswrite - disable verity, reboot if needed, and remount image
972#
973# Easy way to make system.img/etc writable
974function syswrite() {
975 adb wait-for-device && adb root || return 1
976 if [[ $(adb disable-verity | grep "reboot") ]]; then
977 echo "rebooting"
978 adb reboot && adb wait-for-device && adb root || return 1
979 fi
980 adb wait-for-device && adb remount || return 1
981}
982
Iliyan Malcheve675cfb2014-11-03 17:04:47 -0800983# coredump_setup - enable core dumps globally for any process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700984# that has the core-file-size limit set correctly
985#
Iliyan Malchevaf5de972014-11-04 20:57:37 -0800986# NOTE: You must call also coredump_enable for a specific process
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700987# if its core-file-size limit is not set already.
988# NOTE: Core dumps are written to ramdisk; they will not survive a reboot!
989
Matt Alexanderd9c56562020-05-21 10:49:17 +0000990function coredump_setup()
991{
992 echo "Getting root...";
993 adb root;
994 adb wait-for-device;
Iliyan Malchev248f4d52014-10-28 18:00:42 -0700995
Matt Alexanderd9c56562020-05-21 10:49:17 +0000996 echo "Remounting root partition read-write...";
997 adb shell mount -w -o remount -t rootfs rootfs;
998 sleep 1;
999 adb wait-for-device;
1000 adb shell mkdir -p /cores;
1001 adb shell mount -t tmpfs tmpfs /cores;
1002 adb shell chmod 0777 /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001003
Matt Alexanderd9c56562020-05-21 10:49:17 +00001004 echo "Granting SELinux permission to dump in /cores...";
1005 adb shell restorecon -R /cores;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001006
Matt Alexanderd9c56562020-05-21 10:49:17 +00001007 echo "Set core pattern.";
1008 adb shell 'echo /cores/core.%p > /proc/sys/kernel/core_pattern';
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001009
Ying Wang08800fd2016-03-03 20:57:21 -08001010 echo "Done."
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001011}
1012
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001013# coredump_enable - enable core dumps for the specified process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001014# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001015#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001016# NOTE: coredump_setup must have been called as well for a core
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001017# dump to actually be generated.
1018
Matt Alexanderd9c56562020-05-21 10:49:17 +00001019function coredump_enable()
1020{
1021 local PID=$1;
Ying Wang08800fd2016-03-03 20:57:21 -08001022 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001023 printf "Expecting a PID!\n";
1024 return;
1025 fi;
1026 echo "Setting core limit for $PID to infinite...";
Elliott Hughes910a3552016-03-07 13:53:53 -08001027 adb shell /system/bin/ulimit -p $PID -c unlimited
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001028}
1029
1030# core - send SIGV and pull the core for process
Matt Alexanderd9c56562020-05-21 10:49:17 +00001031# $1 = PID of process (e.g., $(pid mediaserver))
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001032#
Iliyan Malchevaf5de972014-11-04 20:57:37 -08001033# NOTE: coredump_setup must be called once per boot for core dumps to be
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001034# enabled globally.
1035
Matt Alexanderd9c56562020-05-21 10:49:17 +00001036function core()
1037{
1038 local PID=$1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001039
Ying Wang08800fd2016-03-03 20:57:21 -08001040 if [ -z "$PID" ]; then
Matt Alexanderd9c56562020-05-21 10:49:17 +00001041 printf "Expecting a PID!\n";
1042 return;
1043 fi;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001044
Matt Alexanderd9c56562020-05-21 10:49:17 +00001045 local CORENAME=core.$PID;
1046 local COREPATH=/cores/$CORENAME;
1047 local SIG=SEGV;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001048
Matt Alexanderd9c56562020-05-21 10:49:17 +00001049 coredump_enable $1;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001050
Matt Alexanderd9c56562020-05-21 10:49:17 +00001051 local done=0;
Ying Wang08800fd2016-03-03 20:57:21 -08001052 while [ $(adb shell "[ -d /proc/$PID ] && echo -n yes") ]; do
Matt Alexanderd9c56562020-05-21 10:49:17 +00001053 printf "\tSending SIG%s to %d...\n" $SIG $PID;
1054 adb shell kill -$SIG $PID;
1055 sleep 1;
1056 done;
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001057
Matt Alexanderd9c56562020-05-21 10:49:17 +00001058 adb shell "while [ ! -f $COREPATH ] ; do echo waiting for $COREPATH to be generated; sleep 1; done"
1059 echo "Done: core is under $COREPATH on device.";
Iliyan Malchev248f4d52014-10-28 18:00:42 -07001060}
1061
Christopher Tate744ee802009-11-12 15:33:08 -08001062# systemstack - dump the current stack trace of all threads in the system process
1063# to the usual ANR traces file
Matt Alexanderd9c56562020-05-21 10:49:17 +00001064function systemstack()
1065{
Jeff Sharkeyf5824372013-02-19 17:00:46 -08001066 stacks system_server
1067}
1068
Michael Wrightaeed7212014-06-19 19:58:12 -07001069# Read the ELF header from /proc/$PID/exe to determine if the process is
1070# 64-bit.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001071function is64bit()
1072{
Ben Chengfba67bf2014-02-25 10:27:07 -08001073 local PID="$1"
Matt Alexanderd9c56562020-05-21 10:49:17 +00001074 if [ "$PID" ] ; then
1075 if [[ "$(adb shell cat /proc/$PID/exe | xxd -l 1 -s 4 -p)" -eq "02" ]] ; then
Ben Chengfba67bf2014-02-25 10:27:07 -08001076 echo "64"
1077 else
1078 echo ""
1079 fi
1080 else
1081 echo ""
1082 fi
1083}
1084
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001085case `uname -s` in
1086 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001087 function sgrep()
1088 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001089 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cc|cpp|hpp|S|java|kt|xml|sh|mk|aidl|vts|proto)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001090 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001091 }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001092
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001093 ;;
1094 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001095 function sgrep()
1096 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001097 find . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.\(c\|h\|cc\|cpp\|hpp\|S\|java\|kt\|xml\|sh\|mk\|aidl\|vts\|proto\)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001098 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001099 }
1100 ;;
1101esac
1102
Matt Alexanderd9c56562020-05-21 10:49:17 +00001103function gettargetarch
1104{
Raghu Gandham8da43102012-07-25 19:57:22 -07001105 get_build_var TARGET_ARCH
1106}
1107
Matt Alexanderd9c56562020-05-21 10:49:17 +00001108function ggrep()
1109{
Mike Frysinger5e479732015-09-22 18:13:48 -04001110 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.gradle" \
1111 -exec grep --color -n "$@" {} +
Jon Boekenoogencbca56f2014-04-07 10:57:38 -07001112}
1113
Matt Alexanderd9c56562020-05-21 10:49:17 +00001114function gogrep()
1115{
Orion Hodson831472d2019-10-25 11:35:15 +01001116 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.go" \
1117 -exec grep --color -n "$@" {} +
1118}
1119
Matt Alexanderd9c56562020-05-21 10:49:17 +00001120function jgrep()
1121{
Mike Frysinger5e479732015-09-22 18:13:48 -04001122 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.java" \
1123 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001124}
1125
Alistair Delva176e5342021-02-22 13:31:26 -08001126function rsgrep()
Jeff Vander Stoep1431ab82021-02-02 19:18:26 +01001127{
1128 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rs" \
1129 -exec grep --color -n "$@" {} +
1130}
1131
Taesu Leeea0cecd2020-10-28 11:05:18 +09001132function ktgrep()
1133{
1134 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.kt" \
1135 -exec grep --color -n "$@" {} +
1136}
1137
Matt Alexanderd9c56562020-05-21 10:49:17 +00001138function cgrep()
1139{
Mike Frysinger5e479732015-09-22 18:13:48 -04001140 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f \( -name '*.c' -o -name '*.cc' -o -name '*.cpp' -o -name '*.h' -o -name '*.hpp' \) \
1141 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001142}
1143
Matt Alexanderd9c56562020-05-21 10:49:17 +00001144function resgrep()
1145{
Christopher Ferris55257d22017-03-23 11:08:58 -07001146 local dir
Mike Frysinger5e479732015-09-22 18:13:48 -04001147 for dir in `find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -name res -type d`; do
1148 find $dir -type f -name '*\.xml' -exec grep --color -n "$@" {} +
1149 done
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001150}
1151
Matt Alexanderd9c56562020-05-21 10:49:17 +00001152function mangrep()
1153{
Mike Frysinger5e479732015-09-22 18:13:48 -04001154 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'AndroidManifest.xml' \
1155 -exec grep --color -n "$@" {} +
Jeff Sharkey50b61e92013-03-08 10:20:47 -08001156}
1157
Matt Alexanderd9c56562020-05-21 10:49:17 +00001158function owngrep()
1159{
Jeff Sharkeyf17cddf2019-08-21 12:51:26 -06001160 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -type f -name 'OWNERS' \
1161 -exec grep --color -n "$@" {} +
1162}
1163
Matt Alexanderd9c56562020-05-21 10:49:17 +00001164function sepgrep()
1165{
Mike Frysinger5e479732015-09-22 18:13:48 -04001166 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o -name sepolicy -type d \
1167 -exec grep --color -n -r --exclude-dir=\.git "$@" {} +
Alex Klyubinba5fc8e2013-05-06 14:11:48 -07001168}
1169
Matt Alexanderd9c56562020-05-21 10:49:17 +00001170function rcgrep()
1171{
Mike Frysinger5e479732015-09-22 18:13:48 -04001172 find . -name .repo -prune -o -name .git -prune -o -name out -prune -o -type f -name "*\.rc*" \
1173 -exec grep --color -n "$@" {} +
Jeff Sharkeyea0068a2015-02-26 14:13:46 -08001174}
1175
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001176case `uname -s` in
1177 Darwin)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001178 function mgrep()
1179 {
Orion Hodson831472d2019-10-25 11:35:15 +01001180 find -E . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -iregex '.*/(Makefile|Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001181 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001182 }
1183
Matt Alexanderd9c56562020-05-21 10:49:17 +00001184 function treegrep()
1185 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001186 find -E . -name .repo -prune -o -name .git -prune -o -type f -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' \
Mike Frysinger5e479732015-09-22 18:13:48 -04001187 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001188 }
1189
1190 ;;
1191 *)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001192 function mgrep()
1193 {
Orion Hodson831472d2019-10-25 11:35:15 +01001194 find . -name .repo -prune -o -name .git -prune -o -path ./out -prune -o \( -regextype posix-egrep -iregex '(.*\/Makefile|.*\/Makefile\..*|.*\.make|.*\.mak|.*\.mk|.*\.bp)' -o -regextype posix-extended -regex '(.*/)?(build|soong)/.*[^/]*\.go' \) -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001195 -exec grep --color -n "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001196 }
1197
Matt Alexanderd9c56562020-05-21 10:49:17 +00001198 function treegrep()
1199 {
Taesu Leeea0cecd2020-10-28 11:05:18 +09001200 find . -name .repo -prune -o -name .git -prune -o -regextype posix-egrep -iregex '.*\.(c|h|cpp|hpp|S|java|kt|xml)' -type f \
Mike Frysinger5e479732015-09-22 18:13:48 -04001201 -exec grep --color -n -i "$@" {} +
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001202 }
1203
1204 ;;
1205esac
1206
Matt Alexanderd9c56562020-05-21 10:49:17 +00001207function getprebuilt
1208{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001209 get_abs_build_var ANDROID_PREBUILTS
1210}
1211
Matt Alexanderd9c56562020-05-21 10:49:17 +00001212function tracedmdump()
1213{
Christopher Ferris55257d22017-03-23 11:08:58 -07001214 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001215 if [ ! "$T" ]; then
1216 echo "Couldn't locate the top of the tree. Try setting TOP."
1217 return
1218 fi
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001219 local prebuiltdir=$(getprebuilt)
Raghu Gandham8da43102012-07-25 19:57:22 -07001220 local arch=$(gettargetarch)
1221 local KERNEL=$T/prebuilts/qemu-kernel/$arch/vmlinux-qemu
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001222
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001223 local TRACE=$1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001224 if [ ! "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001225 echo "usage: tracedmdump tracename"
1226 return
1227 fi
1228
Matt Alexanderd9c56562020-05-21 10:49:17 +00001229 if [ ! -r "$KERNEL" ] ; then
Jack Veenstra60116fc2009-04-09 18:12:34 -07001230 echo "Error: cannot find kernel: '$KERNEL'"
1231 return
1232 fi
1233
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001234 local BASETRACE=$(basename $TRACE)
Matt Alexanderd9c56562020-05-21 10:49:17 +00001235 if [ "$BASETRACE" = "$TRACE" ] ; then
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001236 TRACE=$ANDROID_PRODUCT_OUT/traces/$TRACE
1237 fi
1238
1239 echo "post-processing traces..."
1240 rm -f $TRACE/qtrace.dexlist
1241 post_trace $TRACE
1242 if [ $? -ne 0 ]; then
1243 echo "***"
1244 echo "*** Error: malformed trace. Did you remember to exit the emulator?"
1245 echo "***"
1246 return
1247 fi
1248 echo "generating dexlist output..."
1249 /bin/ls $ANDROID_PRODUCT_OUT/system/framework/*.jar $ANDROID_PRODUCT_OUT/system/app/*.apk $ANDROID_PRODUCT_OUT/data/app/*.apk 2>/dev/null | xargs dexlist > $TRACE/qtrace.dexlist
1250 echo "generating dmtrace data..."
1251 q2dm -r $ANDROID_PRODUCT_OUT/symbols $TRACE $KERNEL $TRACE/dmtrace || return
1252 echo "generating html file..."
1253 dmtracedump -h $TRACE/dmtrace >| $TRACE/dmtrace.html || return
1254 echo "done, see $TRACE/dmtrace.html for details"
1255 echo "or run:"
1256 echo " traceview $TRACE/dmtrace"
1257}
1258
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001259# communicate with a running device or emulator, set up necessary state,
1260# and run the hat command.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001261function runhat()
1262{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001263 # process standard adb options
1264 local adbTarget=""
Matt Alexanderd9c56562020-05-21 10:49:17 +00001265 if [ "$1" = "-d" -o "$1" = "-e" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001266 adbTarget=$1
1267 shift 1
Matt Alexanderd9c56562020-05-21 10:49:17 +00001268 elif [ "$1" = "-s" ]; then
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001269 adbTarget="$1 $2"
1270 shift 2
1271 fi
1272 local adbOptions=${adbTarget}
Matt Alexanderd9c56562020-05-21 10:49:17 +00001273 #echo adbOptions = ${adbOptions}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001274
1275 # runhat options
1276 local targetPid=$1
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001277
Matt Alexanderd9c56562020-05-21 10:49:17 +00001278 if [ "$targetPid" = "" ]; then
Andy McFaddenb6289852010-07-12 08:00:19 -07001279 echo "Usage: runhat [ -d | -e | -s serial ] target-pid"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001280 return
1281 fi
1282
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001283 # confirm hat is available
1284 if [ -z $(which hat) ]; then
1285 echo "hat is not available in this configuration."
1286 return
1287 fi
1288
Andy McFaddenb6289852010-07-12 08:00:19 -07001289 # issue "am" command to cause the hprof dump
Nick Kralevich9948b1e2014-07-18 15:45:38 -07001290 local devFile=/data/local/tmp/hprof-$targetPid
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001291 echo "Poking $targetPid and waiting for data..."
Dianne Hackborn6b9549f2012-09-26 15:00:59 -07001292 echo "Storing data at $devFile"
Andy McFaddenb6289852010-07-12 08:00:19 -07001293 adb ${adbOptions} shell am dumpheap $targetPid $devFile
The Android Open Source Project88b60792009-03-03 19:28:42 -08001294 echo "Press enter when logcat shows \"hprof: heap dump completed\""
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001295 echo -n "> "
1296 read
1297
The Android Open Source Project88b60792009-03-03 19:28:42 -08001298 local localFile=/tmp/$$-hprof
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001299
The Android Open Source Project88b60792009-03-03 19:28:42 -08001300 echo "Retrieving file $devFile..."
1301 adb ${adbOptions} pull $devFile $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001302
The Android Open Source Project88b60792009-03-03 19:28:42 -08001303 adb ${adbOptions} shell rm $devFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001304
The Android Open Source Project88b60792009-03-03 19:28:42 -08001305 echo "Running hat on $localFile"
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001306 echo "View the output by pointing your browser at http://localhost:7000/"
1307 echo ""
Dianne Hackborn6e4e1bb2011-11-10 15:19:51 -08001308 hat -JXmx512m $localFile
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001309}
1310
Matt Alexanderd9c56562020-05-21 10:49:17 +00001311function getbugreports()
1312{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001313 local reports=(`adb shell ls /sdcard/bugreports | tr -d '\r'`)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001314
1315 if [ ! "$reports" ]; then
1316 echo "Could not locate any bugreports."
1317 return
1318 fi
1319
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001320 local report
1321 for report in ${reports[@]}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001322 do
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001323 echo "/sdcard/bugreports/${report}"
1324 adb pull /sdcard/bugreports/${report} ${report}
1325 gunzip ${report}
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001326 done
1327}
1328
Matt Alexanderd9c56562020-05-21 10:49:17 +00001329function getsdcardpath()
1330{
Victoria Lease1b296b42012-08-21 15:44:06 -07001331 adb ${adbOptions} shell echo -n \$\{EXTERNAL_STORAGE\}
1332}
1333
Matt Alexanderd9c56562020-05-21 10:49:17 +00001334function getscreenshotpath()
1335{
Victoria Lease1b296b42012-08-21 15:44:06 -07001336 echo "$(getsdcardpath)/Pictures/Screenshots"
1337}
1338
Matt Alexanderd9c56562020-05-21 10:49:17 +00001339function getlastscreenshot()
1340{
Victoria Lease1b296b42012-08-21 15:44:06 -07001341 local screenshot_path=$(getscreenshotpath)
1342 local screenshot=`adb ${adbOptions} ls ${screenshot_path} | grep Screenshot_[0-9-]*.*\.png | sort -rk 3 | cut -d " " -f 4 | head -n 1`
Matt Alexanderd9c56562020-05-21 10:49:17 +00001343 if [ "$screenshot" = "" ]; then
Victoria Lease1b296b42012-08-21 15:44:06 -07001344 echo "No screenshots found."
1345 return
1346 fi
1347 echo "${screenshot}"
1348 adb ${adbOptions} pull ${screenshot_path}/${screenshot}
1349}
1350
Matt Alexanderd9c56562020-05-21 10:49:17 +00001351function startviewserver()
1352{
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001353 local port=4939
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001354 if [ $# -gt 0 ]; then
1355 port=$1
1356 fi
1357 adb shell service call window 1 i32 $port
1358}
1359
Matt Alexanderd9c56562020-05-21 10:49:17 +00001360function stopviewserver()
1361{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001362 adb shell service call window 2
1363}
1364
Matt Alexanderd9c56562020-05-21 10:49:17 +00001365function isviewserverstarted()
1366{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001367 adb shell service call window 3
1368}
1369
Matt Alexanderd9c56562020-05-21 10:49:17 +00001370function key_home()
1371{
Romain Guyb84049a2010-10-04 16:56:11 -07001372 adb shell input keyevent 3
1373}
1374
Matt Alexanderd9c56562020-05-21 10:49:17 +00001375function key_back()
1376{
Romain Guyb84049a2010-10-04 16:56:11 -07001377 adb shell input keyevent 4
1378}
1379
Matt Alexanderd9c56562020-05-21 10:49:17 +00001380function key_menu()
1381{
Romain Guyb84049a2010-10-04 16:56:11 -07001382 adb shell input keyevent 82
1383}
1384
Matt Alexanderd9c56562020-05-21 10:49:17 +00001385function smoketest()
1386{
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001387 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1388 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1389 return
1390 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001391 local T=$(gettop)
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001392 if [ ! "$T" ]; then
1393 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1394 return
1395 fi
1396
Ying Wang9cd17642012-12-13 10:52:07 -08001397 (\cd "$T" && mmm tests/SmokeTest) &&
The Android Open Source Projectb6c1cf62008-10-21 07:00:00 -07001398 adb uninstall com.android.smoketest > /dev/null &&
1399 adb uninstall com.android.smoketest.tests > /dev/null &&
1400 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTestApp.apk &&
1401 adb install $ANDROID_PRODUCT_OUT/data/app/SmokeTest.apk &&
1402 adb shell am instrument -w com.android.smoketest.tests/android.test.InstrumentationTestRunner
1403}
1404
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001405# simple shortcut to the runtest command
Matt Alexanderd9c56562020-05-21 10:49:17 +00001406function runtest()
1407{
Christopher Ferris55257d22017-03-23 11:08:58 -07001408 local T=$(gettop)
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001409 if [ ! "$T" ]; then
1410 echo "Couldn't locate the top of the tree. Try setting TOP." >&2
1411 return
1412 fi
Brett Chabot3fb149d2009-10-21 20:05:26 -07001413 ("$T"/development/testrunner/runtest.py $@)
Brett Chabot762748c2009-03-27 10:25:11 -07001414}
1415
The Android Open Source Project88b60792009-03-03 19:28:42 -08001416function godir () {
1417 if [[ -z "$1" ]]; then
1418 echo "Usage: godir <regex>"
1419 return
1420 fi
Christopher Ferris55257d22017-03-23 11:08:58 -07001421 local T=$(gettop)
1422 local FILELIST
Matt Alexanderd9c56562020-05-21 10:49:17 +00001423 if [ ! "$OUT_DIR" = "" ]; then
Brian Carlstromf2257422015-09-30 20:28:54 -07001424 mkdir -p $OUT_DIR
1425 FILELIST=$OUT_DIR/filelist
1426 else
1427 FILELIST=$T/filelist
1428 fi
1429 if [[ ! -f $FILELIST ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001430 echo -n "Creating index..."
Brian Carlstromf2257422015-09-30 20:28:54 -07001431 (\cd $T; find . -wholename ./out -prune -o -wholename ./.repo -prune -o -type f > $FILELIST)
The Android Open Source Project88b60792009-03-03 19:28:42 -08001432 echo " Done"
1433 echo ""
1434 fi
1435 local lines
Brian Carlstromf2257422015-09-30 20:28:54 -07001436 lines=($(\grep "$1" $FILELIST | sed -e 's/\/[^/]*$//' | sort | uniq))
Matt Alexanderd9c56562020-05-21 10:49:17 +00001437 if [[ ${#lines[@]} = 0 ]]; then
The Android Open Source Project88b60792009-03-03 19:28:42 -08001438 echo "Not found"
1439 return
1440 fi
1441 local pathname
1442 local choice
1443 if [[ ${#lines[@]} > 1 ]]; then
1444 while [[ -z "$pathname" ]]; do
1445 local index=1
1446 local line
1447 for line in ${lines[@]}; do
1448 printf "%6s %s\n" "[$index]" $line
Doug Zongker29034982011-04-22 08:16:56 -07001449 index=$(($index + 1))
The Android Open Source Project88b60792009-03-03 19:28:42 -08001450 done
1451 echo
1452 echo -n "Select one: "
1453 unset choice
1454 read choice
1455 if [[ $choice -gt ${#lines[@]} || $choice -lt 1 ]]; then
1456 echo "Invalid choice"
1457 continue
1458 fi
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001459 pathname=${lines[@]:$(($choice-1)):1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001460 done
1461 else
Guillaume Chelfice000fd2019-10-03 12:02:46 +02001462 pathname=${lines[@]:0:1}
The Android Open Source Project88b60792009-03-03 19:28:42 -08001463 fi
Ying Wang9cd17642012-12-13 10:52:07 -08001464 \cd $T/$pathname
The Android Open Source Project88b60792009-03-03 19:28:42 -08001465}
1466
Steven Moreland62054a42018-12-06 10:11:40 -08001467# Update module-info.json in out.
1468function refreshmod() {
1469 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1470 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1471 return 1
1472 fi
1473
1474 echo "Refreshing modules (building module-info.json). Log at $ANDROID_PRODUCT_OUT/module-info.json.build.log." >&2
1475
1476 # for the output of the next command
1477 mkdir -p $ANDROID_PRODUCT_OUT || return 1
1478
1479 # Note, can't use absolute path because of the way make works.
Alessandro Astonec8771be2020-05-10 11:27:57 +02001480 m $(get_build_var PRODUCT_OUT)/module-info.json \
Steven Moreland62054a42018-12-06 10:11:40 -08001481 > $ANDROID_PRODUCT_OUT/module-info.json.build.log 2>&1
1482}
1483
Cole Faust3e192382021-10-25 13:29:15 -07001484# Verifies that module-info.txt exists, returning nonzero if it doesn't.
Cole Faust24c36db2021-01-23 02:39:37 +00001485function verifymodinfo() {
Steven Moreland62054a42018-12-06 10:11:40 -08001486 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001487 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
1488 echo "No ANDROID_PRODUCT_OUT. Try running 'lunch' first." >&2
1489 fi
Steven Moreland62054a42018-12-06 10:11:40 -08001490 return 1
1491 fi
1492
1493 if [ ! -f "$ANDROID_PRODUCT_OUT/module-info.json" ]; then
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001494 if [ "$QUIET_VERIFYMODINFO" != "true" ] ; then
Cole Faust3e192382021-10-25 13:29:15 -07001495 echo "Could not find module-info.json. Please run 'refreshmod' first." >&2
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001496 fi
1497 return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001498 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001499}
1500
1501# List all modules for the current device, as cached in module-info.json. If any build change is
1502# made and it should be reflected in the output, you should run 'refreshmod' first.
1503function allmod() {
1504 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001505
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001506 python3 -c "import json; print('\n'.join(sorted(json.load(open('$ANDROID_PRODUCT_OUT/module-info.json')).keys())))"
Steven Moreland62054a42018-12-06 10:11:40 -08001507}
1508
Joe Onorato2c1aa472021-02-25 16:42:39 -08001509# Get the path of a specific module in the android tree, as cached in module-info.json.
1510# If any build change is made, and it should be reflected in the output, you should run
1511# 'refreshmod' first. Note: This is the inverse of dirmods.
Rett Berg78d1c932019-01-24 14:34:23 -08001512function pathmod() {
Steven Moreland62054a42018-12-06 10:11:40 -08001513 if [[ $# -ne 1 ]]; then
Rett Berg78d1c932019-01-24 14:34:23 -08001514 echo "usage: pathmod <module>" >&2
Steven Moreland62054a42018-12-06 10:11:40 -08001515 return 1
1516 fi
1517
Cole Faust24c36db2021-01-23 02:39:37 +00001518 verifymodinfo || return 1
Steven Moreland62054a42018-12-06 10:11:40 -08001519
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001520 local relpath=$(python3 -c "import json, os
Steven Moreland62054a42018-12-06 10:11:40 -08001521module = '$1'
1522module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1523if module not in module_info:
1524 exit(1)
LuK1337b6a78192020-01-12 03:12:17 +01001525print(module_info[module]['path'][0])" 2>/dev/null)
Steven Moreland62054a42018-12-06 10:11:40 -08001526
1527 if [ -z "$relpath" ]; then
1528 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)." >&2
1529 return 1
1530 else
Rett Berg78d1c932019-01-24 14:34:23 -08001531 echo "$ANDROID_BUILD_TOP/$relpath"
Steven Moreland62054a42018-12-06 10:11:40 -08001532 fi
1533}
1534
Joe Onorato2c1aa472021-02-25 16:42:39 -08001535# Get the path of a specific module in the android tree, as cached in module-info.json.
1536# If any build change is made, and it should be reflected in the output, you should run
1537# 'refreshmod' first. Note: This is the inverse of pathmod.
1538function dirmods() {
1539 if [[ $# -ne 1 ]]; then
1540 echo "usage: dirmods <path>" >&2
1541 return 1
1542 fi
1543
1544 verifymodinfo || return 1
1545
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001546 python3 -c "import json, os
Joe Onorato2c1aa472021-02-25 16:42:39 -08001547dir = '$1'
1548while dir.endswith('/'):
1549 dir = dir[:-1]
1550prefix = dir + '/'
1551module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1552results = set()
1553for m in module_info.values():
1554 for path in m.get(u'path', []):
1555 if path == dir or path.startswith(prefix):
1556 name = m.get(u'module_name')
1557 if name:
1558 results.add(name)
1559for name in sorted(results):
1560 print(name)
1561"
1562}
1563
1564
Rett Berg78d1c932019-01-24 14:34:23 -08001565# Go to a specific module in the android tree, as cached in module-info.json. If any build change
1566# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1567function gomod() {
1568 if [[ $# -ne 1 ]]; then
1569 echo "usage: gomod <module>" >&2
1570 return 1
1571 fi
1572
1573 local path="$(pathmod $@)"
1574 if [ -z "$path" ]; then
1575 return 1
1576 fi
1577 cd $path
1578}
1579
Cole Faust24c36db2021-01-23 02:39:37 +00001580# Gets the list of a module's installed outputs, as cached in module-info.json.
1581# If any build change is made, and it should be reflected in the output, you should run 'refreshmod' first.
1582function outmod() {
1583 if [[ $# -ne 1 ]]; then
1584 echo "usage: outmod <module>" >&2
1585 return 1
1586 fi
1587
1588 verifymodinfo || return 1
1589
1590 local relpath
Joe Onorato4acbe3b2021-04-29 15:31:42 -07001591 relpath=$(python3 -c "import json, os
Cole Faust24c36db2021-01-23 02:39:37 +00001592module = '$1'
1593module_info = json.load(open('$ANDROID_PRODUCT_OUT/module-info.json'))
1594if module not in module_info:
1595 exit(1)
1596for output in module_info[module]['installed']:
1597 print(os.path.join('$ANDROID_BUILD_TOP', output))" 2>/dev/null)
1598
1599 if [ $? -ne 0 ]; then
1600 echo "Could not find module '$1' (try 'refreshmod' if there have been build changes?)" >&2
1601 return 1
1602 elif [ ! -z "$relpath" ]; then
1603 echo "$relpath"
1604 fi
1605}
1606
1607# adb install a module's apk, as cached in module-info.json. If any build change
1608# is made, and it should be reflected in the output, you should run 'refreshmod' first.
1609# Usage: installmod [adb install arguments] <module>
1610# For example: installmod -r Dialer -> adb install -r /path/to/Dialer.apk
1611function installmod() {
1612 if [[ $# -eq 0 ]]; then
1613 echo "usage: installmod [adb install arguments] <module>" >&2
Cole Faust3e192382021-10-25 13:29:15 -07001614 echo "" >&2
1615 echo "Only flags to be passed after the \"install\" in adb install are supported," >&2
1616 echo "with the exception of -s. If -s is passed it will be placed before the \"install\"." >&2
1617 echo "-s must be the first flag passed if it exists." >&2
Cole Faust24c36db2021-01-23 02:39:37 +00001618 return 1
1619 fi
1620
1621 local _path
1622 _path=$(outmod ${@:$#:1})
1623 if [ $? -ne 0 ]; then
1624 return 1
1625 fi
1626
1627 _path=$(echo "$_path" | grep -E \\.apk$ | head -n 1)
1628 if [ -z "$_path" ]; then
1629 echo "Module '$1' does not produce a file ending with .apk (try 'refreshmod' if there have been build changes?)" >&2
1630 return 1
1631 fi
Cole Faust3e192382021-10-25 13:29:15 -07001632 local serial_device=""
1633 if [[ "$1" == "-s" ]]; then
1634 if [[ $# -le 2 ]]; then
1635 echo "-s requires an argument" >&2
1636 return 1
1637 fi
1638 serial_device="-s $2"
1639 shift 2
1640 fi
Cole Faust24c36db2021-01-23 02:39:37 +00001641 local length=$(( $# - 1 ))
Cole Faust3e192382021-10-25 13:29:15 -07001642 echo adb $serial_device install ${@:1:$length} $_path
1643 adb $serial_device install ${@:1:$length} $_path
Cole Faust24c36db2021-01-23 02:39:37 +00001644}
1645
dimitry73b84812018-12-11 18:06:00 +01001646function _complete_android_module_names() {
Steven Moreland62054a42018-12-06 10:11:40 -08001647 local word=${COMP_WORDS[COMP_CWORD]}
Joe Onorato0bac4fe2021-04-07 08:51:28 -07001648 COMPREPLY=( $(QUIET_VERIFYMODINFO=true allmod | grep -E "^$word") )
Steven Moreland62054a42018-12-06 10:11:40 -08001649}
1650
Alex Rayf0d08eb2013-03-08 15:15:06 -08001651# Print colored exit condition
1652function pez {
Michael Wrighteb733842013-03-08 17:34:02 -08001653 "$@"
1654 local retval=$?
Matt Alexanderd9c56562020-05-21 10:49:17 +00001655 if [ $retval -ne 0 ]
1656 then
Jacky Cao89483b82015-05-15 22:12:53 +08001657 echo $'\E'"[0;31mFAILURE\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001658 else
Jacky Cao89483b82015-05-15 22:12:53 +08001659 echo $'\E'"[0;32mSUCCESS\e[00m"
Michael Wrighteb733842013-03-08 17:34:02 -08001660 fi
1661 return $retval
Alex Rayf0d08eb2013-03-08 15:15:06 -08001662}
1663
Matt Alexanderd9c56562020-05-21 10:49:17 +00001664function get_make_command()
1665{
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001666 # If we're in the top of an Android tree, use soong_ui.bash instead of make
1667 if [ -f build/soong/soong_ui.bash ]; then
Dan Willemsene9842242017-07-28 13:00:13 -07001668 # Always use the real make if -C is passed in
1669 for arg in "$@"; do
1670 if [[ $arg == -C* ]]; then
1671 echo command make
1672 return
1673 fi
1674 done
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001675 echo build/soong/soong_ui.bash --make-mode
1676 else
1677 echo command make
1678 fi
Ying Wanged21d4c2014-08-24 22:14:19 -07001679}
1680
Matt Alexanderd9c56562020-05-21 10:49:17 +00001681function _wrap_build()
1682{
Sasha Smundak9f27cc02019-01-31 13:25:31 -08001683 if [[ "${ANDROID_QUIET_BUILD:-}" == true ]]; then
1684 "$@"
1685 return $?
1686 fi
Ed Heylcc6be0a2014-06-18 14:55:58 -07001687 local start_time=$(date +"%s")
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001688 "$@"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001689 local ret=$?
1690 local end_time=$(date +"%s")
1691 local tdiff=$(($end_time-$start_time))
1692 local hours=$(($tdiff / 3600 ))
1693 local mins=$((($tdiff % 3600) / 60))
1694 local secs=$(($tdiff % 60))
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001695 local ncolors=$(tput colors 2>/dev/null)
1696 if [ -n "$ncolors" ] && [ $ncolors -ge 8 ]; then
Jacky Cao89483b82015-05-15 22:12:53 +08001697 color_failed=$'\E'"[0;31m"
1698 color_success=$'\E'"[0;32m"
Kousik Kumar09af2542021-08-19 16:13:32 -04001699 color_warning=$'\E'"[0;33m"
Jacky Cao89483b82015-05-15 22:12:53 +08001700 color_reset=$'\E'"[00m"
Greg Hackmannd95c7f72014-06-23 14:05:06 -07001701 else
1702 color_failed=""
1703 color_success=""
1704 color_reset=""
1705 fi
Kousik Kumar09af2542021-08-19 16:13:32 -04001706
1707 if [[ "x${USE_RBE}" == "x" && $mins -gt 15 && "${ANDROID_BUILD_ENVIRONMENT_CONFIG}" == "googler" ]]; then
1708 echo
1709 echo "${color_warning}Start using RBE (http://go/build-fast) to get faster builds!${color_reset}"
1710 fi
1711
Ed Heylcc6be0a2014-06-18 14:55:58 -07001712 echo
Matt Alexanderd9c56562020-05-21 10:49:17 +00001713 if [ $ret -eq 0 ] ; then
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001714 echo -n "${color_success}#### build completed successfully "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001715 else
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001716 echo -n "${color_failed}#### failed to build some targets "
Ed Heylcc6be0a2014-06-18 14:55:58 -07001717 fi
Matt Alexanderd9c56562020-05-21 10:49:17 +00001718 if [ $hours -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001719 printf "(%02g:%02g:%02g (hh:mm:ss))" $hours $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001720 elif [ $mins -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001721 printf "(%02g:%02g (mm:ss))" $mins $secs
Matt Alexanderd9c56562020-05-21 10:49:17 +00001722 elif [ $secs -gt 0 ] ; then
Ed Heylcc6be0a2014-06-18 14:55:58 -07001723 printf "(%s seconds)" $secs
1724 fi
Jacky Cao89483b82015-05-15 22:12:53 +08001725 echo " ####${color_reset}"
Ed Heylcc6be0a2014-06-18 14:55:58 -07001726 echo
1727 return $ret
1728}
1729
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001730function _trigger_build()
1731(
1732 local -r bc="$1"; shift
1733 if T="$(gettop)"; then
1734 _wrap_build "$T/build/soong/soong_ui.bash" --build-mode --${bc} --dir="$(pwd)" "$@"
1735 else
Jingwen Chend728ee12021-05-18 06:02:53 +00001736 >&2 echo "Couldn't locate the top of the tree. Try setting TOP."
1737 return 1
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001738 fi
1739)
1740
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001741# Convenience entry point (like m) to use Bazel in AOSP.
Jingwen Chend728ee12021-05-18 06:02:53 +00001742function b()
1743(
1744 # Generate BUILD, bzl files into the synthetic Bazel workspace (out/soong/workspace).
Lukacs T. Berki3fef6602021-09-07 08:18:35 +02001745 _trigger_build "all-modules" bp2build USE_BAZEL_ANALYSIS= || return 1
Jingwen Chend728ee12021-05-18 06:02:53 +00001746 # Then, run Bazel using the synthetic workspace as the --package_path.
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001747 if [[ -z "$@" ]]; then
1748 # If there are no args, show help.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001749 bazel help
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001750 else
1751 # Else, always run with the bp2build configuration, which sets Bazel's package path to the synthetic workspace.
Jingwen Chenbfa114d2021-06-17 05:42:43 +00001752 bazel "$@" --config=bp2build
Jingwen Chen69f9ed12021-06-16 09:44:26 +00001753 fi
Jingwen Chend728ee12021-05-18 06:02:53 +00001754)
1755
Patrice Arrudafa7204b2019-06-20 23:40:33 +00001756function m()
1757(
1758 _trigger_build "all-modules" "$@"
1759)
1760
1761function mm()
1762(
1763 _trigger_build "modules-in-a-dir-no-deps" "$@"
1764)
1765
1766function mmm()
1767(
1768 _trigger_build "modules-in-dirs-no-deps" "$@"
1769)
1770
1771function mma()
1772(
1773 _trigger_build "modules-in-a-dir" "$@"
1774)
1775
1776function mmma()
1777(
1778 _trigger_build "modules-in-dirs" "$@"
1779)
1780
Matt Alexanderd9c56562020-05-21 10:49:17 +00001781function make()
1782{
Dan Willemsene9842242017-07-28 13:00:13 -07001783 _wrap_build $(get_make_command "$@") "$@"
Dan Willemsend41ec5a2017-07-12 16:14:50 -07001784}
1785
Matt Alexanderd9c56562020-05-21 10:49:17 +00001786function provision()
1787{
David Zeuthen1b126ff2015-09-30 17:10:48 -04001788 if [ ! "$ANDROID_PRODUCT_OUT" ]; then
1789 echo "Couldn't locate output files. Try running 'lunch' first." >&2
1790 return 1
1791 fi
1792 if [ ! -e "$ANDROID_PRODUCT_OUT/provision-device" ]; then
1793 echo "There is no provisioning script for the device." >&2
1794 return 1
1795 fi
1796
1797 # Check if user really wants to do this.
Matt Alexanderd9c56562020-05-21 10:49:17 +00001798 if [ "$1" = "--no-confirmation" ]; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001799 shift 1
1800 else
1801 echo "This action will reflash your device."
1802 echo ""
1803 echo "ALL DATA ON THE DEVICE WILL BE IRREVOCABLY ERASED."
1804 echo ""
Marie Janssen4afc2c02015-11-10 10:41:15 -08001805 echo -n "Are you sure you want to do this (yes/no)? "
1806 read
Matt Alexanderd9c56562020-05-21 10:49:17 +00001807 if [[ "${REPLY}" != "yes" ]] ; then
David Zeuthen1b126ff2015-09-30 17:10:48 -04001808 echo "Not taking any action. Exiting." >&2
1809 return 1
1810 fi
1811 fi
1812 "$ANDROID_PRODUCT_OUT/provision-device" "$@"
1813}
1814
Jim Tanga881a252018-06-19 16:34:41 +08001815# Zsh needs bashcompinit called to support bash-style completion.
Patrik Fimmldf248e62018-10-15 18:15:12 +02001816function enable_zsh_completion() {
1817 # Don't override user's options if bash-style completion is already enabled.
1818 if ! declare -f complete >/dev/null; then
1819 autoload -U compinit && compinit
1820 autoload -U bashcompinit && bashcompinit
1821 fi
Jim Tanga881a252018-06-19 16:34:41 +08001822}
1823
1824function validate_current_shell() {
1825 local current_sh="$(ps -o command -p $$)"
1826 case "$current_sh" in
Raphael Moll70a86b02011-06-20 16:03:14 -07001827 *bash*)
Jim Tanga881a252018-06-19 16:34:41 +08001828 function check_type() { type -t "$1"; }
Raphael Moll70a86b02011-06-20 16:03:14 -07001829 ;;
Jim Tanga881a252018-06-19 16:34:41 +08001830 *zsh*)
1831 function check_type() { type "$1"; }
Matt Alexanderd9c56562020-05-21 10:49:17 +00001832 enable_zsh_completion ;;
Raphael Moll70a86b02011-06-20 16:03:14 -07001833 *)
Jim Tanga881a252018-06-19 16:34:41 +08001834 echo -e "WARNING: Only bash and zsh are supported.\nUse of other shell would lead to erroneous results."
Raphael Moll70a86b02011-06-20 16:03:14 -07001835 ;;
1836 esac
Jim Tanga881a252018-06-19 16:34:41 +08001837}
The Android Open Source Projectdcc08f02008-12-17 18:03:49 -08001838
1839# Execute the contents of any vendorsetup.sh files we can find.
Dan Willemsend855a722019-02-12 15:52:36 -08001840# Unless we find an allowed-vendorsetup_sh-files file, in which case we'll only
1841# load those.
1842#
1843# This allows loading only approved vendorsetup.sh files
Jim Tanga881a252018-06-19 16:34:41 +08001844function source_vendorsetup() {
Jim Tangc4dba1d2019-07-25 16:54:27 +08001845 unset VENDOR_PYTHONPATH
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001846 local T="$(gettop)"
Dan Willemsend855a722019-02-12 15:52:36 -08001847 allowed=
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001848 for f in $(cd "$T" && find -L device vendor product -maxdepth 4 -name 'allowed-vendorsetup_sh-files' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001849 if [ -n "$allowed" ]; then
1850 echo "More than one 'allowed_vendorsetup_sh-files' file found, not including any vendorsetup.sh files:"
1851 echo " $allowed"
1852 echo " $f"
1853 return
1854 fi
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001855 allowed="$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001856 done
1857
1858 allowed_files=
1859 [ -n "$allowed" ] && allowed_files=$(cat "$allowed")
Jim Tanga881a252018-06-19 16:34:41 +08001860 for dir in device vendor product; do
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001861 for f in $(cd "$T" && test -d $dir && \
Jim Tanga881a252018-06-19 16:34:41 +08001862 find -L $dir -maxdepth 4 -name 'vendorsetup.sh' 2>/dev/null | sort); do
Dan Willemsend855a722019-02-12 15:52:36 -08001863
1864 if [[ -z "$allowed" || "$allowed_files" =~ $f ]]; then
Patrice Arrudaaa4b8242020-10-12 21:29:14 +00001865 echo "including $f"; . "$T/$f"
Dan Willemsend855a722019-02-12 15:52:36 -08001866 else
1867 echo "ignoring $f, not in $allowed"
1868 fi
Jim Tanga881a252018-06-19 16:34:41 +08001869 done
1870 done
1871}
Kenny Root52aa81c2011-07-15 11:07:06 -07001872
Dan Albertbab814f2020-08-26 15:34:53 -07001873function showcommands() {
1874 local T=$(gettop)
1875 if [[ -z "$TARGET_PRODUCT" ]]; then
1876 >&2 echo "TARGET_PRODUCT not set. Run lunch."
1877 return
1878 fi
1879 case $(uname -s) in
1880 Darwin)
1881 PREBUILT_NAME=darwin-x86
1882 ;;
1883 Linux)
1884 PREBUILT_NAME=linux-x86
1885 ;;
1886 *)
1887 >&2 echo Unknown host $(uname -s)
1888 return
1889 ;;
1890 esac
1891 if [[ -z "$OUT_DIR" ]]; then
1892 if [[ -z "$OUT_DIR_COMMON_BASE" ]]; then
1893 OUT_DIR=out
1894 else
1895 OUT_DIR=${OUT_DIR_COMMON_BASE}/${PWD##*/}
1896 fi
1897 fi
1898 if [[ "$1" == "--regenerate" ]]; then
1899 shift 1
1900 NINJA_ARGS="-t commands $@" m
1901 else
1902 (cd $T && prebuilts/build-tools/$PREBUILT_NAME/bin/ninja \
1903 -f $OUT_DIR/combined-${TARGET_PRODUCT}.ninja \
1904 -t commands "$@")
1905 fi
1906}
1907
Jim Tanga881a252018-06-19 16:34:41 +08001908validate_current_shell
1909source_vendorsetup
Kenny Root52aa81c2011-07-15 11:07:06 -07001910addcompletions